#ifndef  FSL_DEMOAPPS_G2D_EIGHTLAYERS_EMULATION_HPP
#define  FSL_DEMOAPPS_G2D_EIGHTLAYERS_EMULATION_HPP
/****************************************************************************************************************************************************
* Copyright (c) 2014 Freescale Semiconductor, Inc.
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*    * Redistributions of source code must retain the above copyright notice,
*      this list of conditions and the following disclaimer.
*
*    * Redistributions in binary form must reproduce the above copyright notice,
*      this list of conditions and the following disclaimer in the documentation
*      and/or other materials provided with the distribution.
*
*    * Neither the name of the Freescale Semiconductor, Inc. nor the names of
*      its contributors may be used to endorse or promote products derived from
*      this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
****************************************************************************************************************************************************/

#ifdef _WIN32
#include <FslBase/BasicTypes.hpp>
#include <Winsock2.h>
extern "C" int gettimeofday(struct timeval * tp, struct timezone * tzp);

struct fb_bitfield {
  uint32_t offset;			/* beginning of bitfield	*/
  uint32_t length;			/* length of bitfield		*/
  uint32_t msb_right;		/* != 0 : Most significant bit is */
  /* right */
};

struct fb_var_screeninfo
{
  uint32_t xres;			/* visible resolution		*/
  uint32_t yres;
  uint32_t xres_virtual;		/* virtual resolution		*/
  uint32_t yres_virtual;
  uint32_t xoffset;			/* offset from virtual to visible */
  uint32_t yoffset;			/* resolution			*/

  uint32_t bits_per_pixel;		/* guess what			*/
  uint32_t grayscale;		/* 0 = color, 1 = grayscale,	*/
  /* >1 = FOURCC			*/
  struct fb_bitfield red;		/* bitfield in fb mem if true color, */
  struct fb_bitfield green;	/* else only length is significant */
  struct fb_bitfield blue;
  struct fb_bitfield transp;	/* transparency			*/

  uint32_t nonstd;			/* != 0 Non standard pixel format */

  uint32_t activate;			/* see FB_ACTIVATE_*		*/

  uint32_t height;			/* height of picture in mm    */
  uint32_t width;			/* width of picture in mm     */

  uint32_t accel_flags;		/* (OBSOLETE) see fb_info.flags */

  /* Timing: All values in pixclocks, except pixclock (of course) */
  uint32_t pixclock;			/* pixel clock in ps (pico seconds) */
  uint32_t left_margin;		/* time from sync to picture	*/
  uint32_t right_margin;		/* time from picture to sync	*/
  uint32_t upper_margin;		/* time from sync to picture	*/
  uint32_t lower_margin;
  uint32_t hsync_len;		/* length of horizontal sync	*/
  uint32_t vsync_len;		/* length of vertical sync	*/
  uint32_t sync;			/* see FB_SYNC_*		*/
  uint32_t vmode;			/* see FB_VMODE_*		*/
  uint32_t rotate;			/* angle we rotate counter clockwise */
  uint32_t colorspace;		/* colorspace for FOURCC-based modes */
  uint32_t reserved[4];
};

struct fb_fix_screeninfo {
  char id[16];			/* identification string eg "TT Builtin" */
  unsigned long smem_start;	/* Start of frame buffer mem */
  /* (physical address) */
  uint32_t smem_len;			/* Length of frame buffer mem */
  uint32_t type;			/* see FB_TYPE_*		*/
  uint32_t type_aux;			/* Interleave for interleaved Planes */
  uint32_t visual;			/* see FB_VISUAL_*		*/
  uint16_t xpanstep;			/* zero if no hardware panning  */
  uint16_t ypanstep;			/* zero if no hardware panning  */
  uint16_t ywrapstep;		/* zero if no hardware ywrap    */
  uint32_t line_length;		/* length of a line in bytes    */
  unsigned long mmio_start;	/* Start of Memory Mapped I/O   */
  /* (physical address) */
  uint32_t mmio_len;			/* Length of Memory Mapped I/O  */
  uint32_t accel;			/* Indicate to driver which	*/
  /*  specific chip/card we have	*/
  uint16_t capabilities;		/* see FB_CAP_*			*/
  uint16_t reserved[2];		/* Reserved for future compatibility */
};
#define FBIOGET_FSCREENINFO 0
#define FBIOGET_VSCREENINFO 0
#define FBIO_WAITFORVSYNC 0
#define FBIOPAN_DISPLAY 0
#define FBIOPUT_VSCREENINFO 0
inline int open(const char*const psz, int v1, int v2) { return -1; }
inline void close(int q) {}
inline int ioctl(int fd, unsigned long request, void*) { return -1; }
#endif

#endif

