/****************************************************************************************************************************************************
 * Copyright (c) 2015 Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 *    * Neither the name of the Freescale Semiconductor, Inc. nor the names of
 *      its contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ****************************************************************************************************************************************************/

#include "MainAtlas.hpp"
#include <cassert>

namespace Fsl
{
  namespace
  {
    NamedAtlasTexture g_entries[] =
    {
      NamedAtlasTexture("Banners", AtlasTextureInfo(Rectangle(-14, -7, 1920, 1080), Rectangle(2, 2, 495, 149))),
      NamedAtlasTexture("Fill", AtlasTextureInfo(Rectangle(342, 272, 32, 32), Rectangle(342, 272, 32, 32))),
      NamedAtlasTexture("FontChars_Font/21", AtlasTextureInfo(Rectangle(275, 371, 18, 38), Rectangle(275, 371, 18, 38))),
      NamedAtlasTexture("FontChars_Font/22", AtlasTextureInfo(Rectangle(211, 482, 26, 25), Rectangle(211, 482, 26, 25))),
      NamedAtlasTexture("FontChars_Font/23", AtlasTextureInfo(Rectangle(239, 472, 31, 38), Rectangle(239, 472, 31, 38))),
      NamedAtlasTexture("FontChars_Font/24", AtlasTextureInfo(Rectangle(207, 153, 29, 44), Rectangle(207, 153, 29, 44))),
      NamedAtlasTexture("FontChars_Font/25", AtlasTextureInfo(Rectangle(238, 289, 41, 39), Rectangle(238, 289, 41, 39))),
      NamedAtlasTexture("FontChars_Font/26", AtlasTextureInfo(Rectangle(252, 241, 40, 39), Rectangle(252, 241, 40, 39))),
      NamedAtlasTexture("FontChars_Font/27", AtlasTextureInfo(Rectangle(374, 153, 18, 25), Rectangle(374, 153, 18, 25))),
      NamedAtlasTexture("FontChars_Font/28", AtlasTextureInfo(Rectangle(24, 423, 22, 49), Rectangle(24, 423, 22, 49))),
      NamedAtlasTexture("FontChars_Font/29", AtlasTextureInfo(Rectangle(25, 315, 22, 49), Rectangle(25, 315, 22, 49))),
      NamedAtlasTexture("FontChars_Font/2A", AtlasTextureInfo(Rectangle(369, 190, 27, 29), Rectangle(369, 190, 27, 29))),
      NamedAtlasTexture("FontChars_Font/2B", AtlasTextureInfo(Rectangle(36, 474, 34, 36), Rectangle(36, 474, 34, 36))),
      NamedAtlasTexture("FontChars_Font/2C", AtlasTextureInfo(Rectangle(191, 482, 18, 26), Rectangle(191, 482, 18, 26))),
      NamedAtlasTexture("FontChars_Font/2D", AtlasTextureInfo(Rectangle(355, 350, 23, 16), Rectangle(355, 350, 23, 16))),
      NamedAtlasTexture("FontChars_Font/2E", AtlasTextureInfo(Rectangle(335, 350, 18, 17), Rectangle(335, 350, 18, 17))),
      NamedAtlasTexture("FontChars_Font/2F", AtlasTextureInfo(Rectangle(259, 428, 28, 40), Rectangle(259, 428, 28, 40))),
      NamedAtlasTexture("FontChars_Font/30", AtlasTextureInfo(Rectangle(253, 195, 29, 39), Rectangle(253, 195, 29, 39))),
      NamedAtlasTexture("FontChars_Font/31", AtlasTextureInfo(Rectangle(315, 194, 22, 39), Rectangle(315, 194, 22, 39))),
      NamedAtlasTexture("FontChars_Font/32", AtlasTextureInfo(Rectangle(273, 330, 28, 39), Rectangle(273, 330, 28, 39))),
      NamedAtlasTexture("FontChars_Font/33", AtlasTextureInfo(Rectangle(281, 282, 28, 39), Rectangle(281, 282, 28, 39))),
      NamedAtlasTexture("FontChars_Font/34", AtlasTextureInfo(Rectangle(263, 153, 29, 39), Rectangle(263, 153, 29, 39))),
      NamedAtlasTexture("FontChars_Font/35", AtlasTextureInfo(Rectangle(272, 470, 28, 40), Rectangle(272, 470, 28, 40))),
      NamedAtlasTexture("FontChars_Font/36", AtlasTextureInfo(Rectangle(284, 194, 29, 39), Rectangle(284, 194, 29, 39))),
      NamedAtlasTexture("FontChars_Font/37", AtlasTextureInfo(Rectangle(222, 247, 28, 40), Rectangle(222, 247, 28, 40))),
      NamedAtlasTexture("FontChars_Font/38", AtlasTextureInfo(Rectangle(294, 153, 29, 39), Rectangle(294, 153, 29, 39))),
      NamedAtlasTexture("FontChars_Font/39", AtlasTextureInfo(Rectangle(242, 330, 29, 39), Rectangle(242, 330, 29, 39))),
      NamedAtlasTexture("FontChars_Font/3A", AtlasTextureInfo(Rectangle(351, 231, 18, 30), Rectangle(351, 231, 18, 30))),
      NamedAtlasTexture("FontChars_Font/3B", AtlasTextureInfo(Rectangle(325, 153, 18, 39), Rectangle(325, 153, 18, 39))),
      NamedAtlasTexture("FontChars_Font/3C", AtlasTextureInfo(Rectangle(2, 476, 32, 33), Rectangle(2, 476, 32, 33))),
      NamedAtlasTexture("FontChars_Font/3D", AtlasTextureInfo(Rectangle(348, 445, 34, 21), Rectangle(348, 445, 34, 21))),
      NamedAtlasTexture("FontChars_Font/3E", AtlasTextureInfo(Rectangle(365, 368, 32, 33), Rectangle(365, 368, 32, 33))),
      NamedAtlasTexture("FontChars_Font/3F", AtlasTextureInfo(Rectangle(294, 235, 24, 39), Rectangle(294, 235, 24, 39))),
      NamedAtlasTexture("FontChars_Font/40", AtlasTextureInfo(Rectangle(2, 153, 49, 52), Rectangle(2, 153, 49, 52))),
      NamedAtlasTexture("FontChars_Font/41", AtlasTextureInfo(Rectangle(72, 461, 46, 45), Rectangle(72, 461, 46, 45))),
      NamedAtlasTexture("FontChars_Font/42", AtlasTextureInfo(Rectangle(170, 294, 31, 45), Rectangle(170, 294, 31, 45))),
      NamedAtlasTexture("FontChars_Font/43", AtlasTextureInfo(Rectangle(120, 449, 38, 45), Rectangle(120, 449, 38, 45))),
      NamedAtlasTexture("FontChars_Font/44", AtlasTextureInfo(Rectangle(97, 247, 37, 45), Rectangle(97, 247, 37, 45))),
      NamedAtlasTexture("FontChars_Font/45", AtlasTextureInfo(Rectangle(136, 294, 32, 45), Rectangle(136, 294, 32, 45))),
      NamedAtlasTexture("FontChars_Font/46", AtlasTextureInfo(Rectangle(175, 200, 29, 45), Rectangle(175, 200, 29, 45))),
      NamedAtlasTexture("FontChars_Font/47", AtlasTextureInfo(Rectangle(49, 308, 42, 45), Rectangle(49, 308, 42, 45))),
      NamedAtlasTexture("FontChars_Font/48", AtlasTextureInfo(Rectangle(97, 200, 38, 45), Rectangle(97, 200, 38, 45))),
      NamedAtlasTexture("FontChars_Font/49", AtlasTextureInfo(Rectangle(202, 247, 18, 45), Rectangle(202, 247, 18, 45))),
      NamedAtlasTexture("FontChars_Font/4A", AtlasTextureInfo(Rectangle(2, 261, 25, 52), Rectangle(2, 261, 25, 52))),
      NamedAtlasTexture("FontChars_Font/4B", AtlasTextureInfo(Rectangle(98, 153, 38, 45), Rectangle(98, 153, 38, 45))),
      NamedAtlasTexture("FontChars_Font/4C", AtlasTextureInfo(Rectangle(141, 388, 31, 45), Rectangle(141, 388, 31, 45))),
      NamedAtlasTexture("FontChars_Font/4D", AtlasTextureInfo(Rectangle(48, 414, 50, 45), Rectangle(48, 414, 50, 45))),
      NamedAtlasTexture("FontChars_Font/4E", AtlasTextureInfo(Rectangle(53, 153, 43, 45), Rectangle(53, 153, 43, 45))),
      NamedAtlasTexture("FontChars_Font/4F", AtlasTextureInfo(Rectangle(49, 261, 46, 45), Rectangle(49, 261, 46, 45))),
      NamedAtlasTexture("FontChars_Font/50", AtlasTextureInfo(Rectangle(141, 341, 32, 45), Rectangle(141, 341, 32, 45))),
      NamedAtlasTexture("FontChars_Font/51", AtlasTextureInfo(Rectangle(2, 207, 47, 52), Rectangle(2, 207, 47, 52))),
      NamedAtlasTexture("FontChars_Font/52", AtlasTextureInfo(Rectangle(137, 200, 36, 45), Rectangle(137, 200, 36, 45))),
      NamedAtlasTexture("FontChars_Font/53", AtlasTextureInfo(Rectangle(176, 153, 29, 45), Rectangle(176, 153, 29, 45))),
      NamedAtlasTexture("FontChars_Font/54", AtlasTextureInfo(Rectangle(136, 247, 37, 45), Rectangle(136, 247, 37, 45))),
      NamedAtlasTexture("FontChars_Font/55", AtlasTextureInfo(Rectangle(99, 355, 40, 45), Rectangle(99, 355, 40, 45))),
      NamedAtlasTexture("FontChars_Font/56", AtlasTextureInfo(Rectangle(51, 207, 44, 45), Rectangle(51, 207, 44, 45))),
      NamedAtlasTexture("FontChars_Font/57", AtlasTextureInfo(Rectangle(45, 366, 52, 46), Rectangle(45, 366, 52, 46))),
      NamedAtlasTexture("FontChars_Font/58", AtlasTextureInfo(Rectangle(93, 308, 41, 45), Rectangle(93, 308, 41, 45))),
      NamedAtlasTexture("FontChars_Font/59", AtlasTextureInfo(Rectangle(100, 402, 39, 45), Rectangle(100, 402, 39, 45))),
      NamedAtlasTexture("FontChars_Font/5A", AtlasTextureInfo(Rectangle(138, 153, 36, 45), Rectangle(138, 153, 36, 45))),
      NamedAtlasTexture("FontChars_Font/5B", AtlasTextureInfo(Rectangle(29, 261, 18, 47), Rectangle(29, 261, 18, 47))),
      NamedAtlasTexture("FontChars_Font/5C", AtlasTextureInfo(Rectangle(238, 153, 23, 40), Rectangle(238, 153, 23, 40))),
      NamedAtlasTexture("FontChars_Font/5D", AtlasTextureInfo(Rectangle(25, 366, 18, 47), Rectangle(25, 366, 18, 47))),
      NamedAtlasTexture("FontChars_Font/5E", AtlasTextureInfo(Rectangle(160, 482, 29, 28), Rectangle(160, 482, 29, 28))),
      NamedAtlasTexture("FontChars_Font/5F", AtlasTextureInfo(Rectangle(120, 496, 36, 14), Rectangle(120, 496, 36, 14))),
      NamedAtlasTexture("FontChars_Font/60", AtlasTextureInfo(Rectangle(328, 448, 18, 18), Rectangle(328, 448, 18, 18))),
      NamedAtlasTexture("FontChars_Font/61", AtlasTextureInfo(Rectangle(339, 194, 28, 35), Rectangle(339, 194, 28, 35))),
      NamedAtlasTexture("FontChars_Font/62", AtlasTextureInfo(Rectangle(160, 435, 31, 45), Rectangle(160, 435, 31, 45))),
      NamedAtlasTexture("FontChars_Font/63", AtlasTextureInfo(Rectangle(311, 276, 29, 35), Rectangle(311, 276, 29, 35))),
      NamedAtlasTexture("FontChars_Font/64", AtlasTextureInfo(Rectangle(174, 388, 31, 45), Rectangle(174, 388, 31, 45))),
      NamedAtlasTexture("FontChars_Font/65", AtlasTextureInfo(Rectangle(320, 235, 29, 35), Rectangle(320, 235, 29, 35))),
      NamedAtlasTexture("FontChars_Font/66", AtlasTextureInfo(Rectangle(175, 247, 25, 45), Rectangle(175, 247, 25, 45))),
      NamedAtlasTexture("FontChars_Font/67", AtlasTextureInfo(Rectangle(207, 384, 32, 42), Rectangle(207, 384, 32, 42))),
      NamedAtlasTexture("FontChars_Font/68", AtlasTextureInfo(Rectangle(175, 341, 30, 45), Rectangle(175, 341, 30, 45))),
      NamedAtlasTexture("FontChars_Font/69", AtlasTextureInfo(Rectangle(203, 294, 17, 44), Rectangle(203, 294, 17, 44))),
      NamedAtlasTexture("FontChars_Font/6A", AtlasTextureInfo(Rectangle(2, 423, 20, 51), Rectangle(2, 423, 20, 51))),
      NamedAtlasTexture("FontChars_Font/6B", AtlasTextureInfo(Rectangle(193, 435, 30, 45), Rectangle(193, 435, 30, 45))),
      NamedAtlasTexture("FontChars_Font/6C", AtlasTextureInfo(Rectangle(206, 200, 17, 45), Rectangle(206, 200, 17, 45))),
      NamedAtlasTexture("FontChars_Font/6D", AtlasTextureInfo(Rectangle(289, 411, 44, 35), Rectangle(289, 411, 44, 35))),
      NamedAtlasTexture("FontChars_Font/6E", AtlasTextureInfo(Rectangle(303, 323, 30, 35), Rectangle(303, 323, 30, 35))),
      NamedAtlasTexture("FontChars_Font/6F", AtlasTextureInfo(Rectangle(302, 469, 33, 35), Rectangle(302, 469, 33, 35))),
      NamedAtlasTexture("FontChars_Font/70", AtlasTextureInfo(Rectangle(225, 428, 32, 42), Rectangle(225, 428, 32, 42))),
      NamedAtlasTexture("FontChars_Font/71", AtlasTextureInfo(Rectangle(241, 384, 32, 42), Rectangle(241, 384, 32, 42))),
      NamedAtlasTexture("FontChars_Font/72", AtlasTextureInfo(Rectangle(335, 313, 25, 35), Rectangle(335, 313, 25, 35))),
      NamedAtlasTexture("FontChars_Font/73", AtlasTextureInfo(Rectangle(339, 369, 24, 35), Rectangle(339, 369, 24, 35))),
      NamedAtlasTexture("FontChars_Font/74", AtlasTextureInfo(Rectangle(225, 199, 26, 40), Rectangle(225, 199, 26, 40))),
      NamedAtlasTexture("FontChars_Font/75", AtlasTextureInfo(Rectangle(371, 468, 31, 35), Rectangle(371, 468, 31, 35))),
      NamedAtlasTexture("FontChars_Font/76", AtlasTextureInfo(Rectangle(337, 468, 32, 35), Rectangle(337, 468, 32, 35))),
      NamedAtlasTexture("FontChars_Font/77", AtlasTextureInfo(Rectangle(295, 371, 42, 35), Rectangle(295, 371, 42, 35))),
      NamedAtlasTexture("FontChars_Font/78", AtlasTextureInfo(Rectangle(335, 408, 33, 35), Rectangle(335, 408, 33, 35))),
      NamedAtlasTexture("FontChars_Font/79", AtlasTextureInfo(Rectangle(207, 340, 33, 42), Rectangle(207, 340, 33, 42))),
      NamedAtlasTexture("FontChars_Font/7A", AtlasTextureInfo(Rectangle(345, 153, 27, 35), Rectangle(345, 153, 27, 35))),
      NamedAtlasTexture("FontChars_Font/7B", AtlasTextureInfo(Rectangle(2, 315, 21, 52), Rectangle(2, 315, 21, 52))),
      NamedAtlasTexture("FontChars_Font/7C", AtlasTextureInfo(Rectangle(222, 289, 14, 40), Rectangle(222, 289, 14, 40))),
      NamedAtlasTexture("FontChars_Font/7D", AtlasTextureInfo(Rectangle(2, 369, 21, 52), Rectangle(2, 369, 21, 52))),
      NamedAtlasTexture("FontChars_Font/7E", AtlasTextureInfo(Rectangle(289, 448, 37, 19), Rectangle(289, 448, 37, 19))),
    };
  }


  std::string MainAtlas::GetName() const
  {
    return std::string("MainAtlas.png");
  }


  int32_t MainAtlas::Count() const
  {
    return 96;
  }


  NamedAtlasTexture MainAtlas::GetEntry(const int32_t index) const
  {
    assert(index >= 0 && index <= Count());
    return g_entries[index];
  }
}
