#ifndef FSLGRAPHICSEGL_WINDOW_ANDROID_EGLNATIVEWINDOWANDROID_HPP
#define FSLGRAPHICSEGL_WINDOW_ANDROID_EGLNATIVEWINDOWANDROID_HPP
#ifdef __ANDROID__
/****************************************************************************************************************************************************
* Copyright (c) 2014 Freescale Semiconductor, Inc.
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*    * Redistributions of source code must retain the above copyright notice,
*      this list of conditions and the following disclaimer.
*
*    * Redistributions in binary form must reproduce the above copyright notice,
*      this list of conditions and the following disclaimer in the documentation
*      and/or other materials provided with the distribution.
*
*    * Neither the name of the Freescale Semiconductor, Inc. nor the names of
*      its contributors may be used to endorse or promote products derived from
*      this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
****************************************************************************************************************************************************/

#include <FslGraphics/Window/NativeWindowSetup.hpp>
#include <FslGraphics/Window/NativeWindowSystemSetup.hpp>
#include <FslGraphicsEGL/Window/IEGLNativeWindow.hpp>
#include <FslGraphicsEGL/Window/IEGLNativeWindowSystem.hpp>
#include <FslGraphicsEGL/Window/NativeEGLSetup.hpp>
#include <android_native_app_glue.h>

namespace Fsl
{
  class INativeWindowEventQueue;

  class EGLNativeWindowSystemAndroid : public IEGLNativeWindowSystem
  {
    android_app* m_pAppState;
  public:
    EGLNativeWindowSystemAndroid(const NativeWindowSystemSetup& nativeWindowSystemSetup);
    virtual ~EGLNativeWindowSystemAndroid();

    virtual EGLNativeDisplayType GetDisplayType() const;
    virtual std::shared_ptr<IEGLNativeWindow> CreateNativeWindow(const NativeWindowSetup& nativeWindowSetup, const NativeEGLSetup& nativeEglSetup);
    virtual bool ProcessMessages(const NativeWindowProcessMessagesArgs& args);
  };


  class EGLNativeWindowAndroid : public IEGLNativeWindow
  {
    std::weak_ptr<INativeWindowEventQueue> m_eventQueue;
    android_app* m_pAppState;
    EGLNativeWindowType m_hWindow;
    EGLDisplay m_hDisplay;
    EGLConfig m_eglConfig;
  public:

    EGLNativeWindowAndroid(const NativeWindowSetup& nativeWindowSetup, const NativeEGLSetup& nativeEglSetup, android_app* pAppState);
    virtual ~EGLNativeWindowAndroid();

    virtual EGLNativeWindowType GetWindowType() const;
  private:
    void WaitForWindowReady();
  };

}

#endif
#endif
